"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const upper_case_first_1 = require("upper-case-first");
class ObjectStack {
    constructor(type, field, parent, isFragment = false) {
        this.type = type;
        this.field = field;
        this.parent = parent;
        this.isFragment = isFragment;
        this.seenFields = new Set();
    }
    get name() {
        const { parent, field, isFragment, type } = this;
        const fieldName = field ? upper_case_first_1.upperCaseFirst(field.responseName) : '';
        const name = `${parent ? parent.name : ''}${fieldName}`;
        return isFragment ? `${name}${type ? type.name : 'Other'}` : name;
    }
    nested(field, type) {
        return new ObjectStack(type, field, this);
    }
    fragment(type) {
        return new ObjectStack(type, this.field, this.parent, true);
    }
    sawField(field) {
        this.seenFields.add(field.responseName);
    }
    hasSeenField(field) {
        return this.seenFields.has(field.responseName);
    }
}
exports.ObjectStack = ObjectStack;
